#!/usr/local/bin/perl
use strict;
use warnings;

use v5.14;
use utf8;
use Unicode::UCD;
use Unicode::Normalize;
use open qw( :encoding(UTF-8) :std );
use charnames qw( :full );

while ( <DATA> )
{
  chomp;
  $_ = NFD( $_ );
  if ( /(\d+)/ )
  {
    say Unicode::UCD::num( $1 );
  }
  else
  {
    say "\\N{", charnames::viacode( ord ), "} is not a number" for split //;
  }
}

__END__
☺☸
٠
١٢٣٤٥٦٧٨٩
๑๒๓๔๕๖๗๘๙
໑໒໓໔໕໖໗໘໙
