#!/usr/local/bin/perl
use strict;
use warnings;

print "Command args = <<@ARGV>>\n";
my $opt_ref = process_options( \@ARGV );
print "Command args = <<@ARGV>>\n";
print "Options:\n", map( { "\t$_ = '$opt_ref->{$_}'\n" } sort keys %$opt_ref );

sub process_options
{
  my $arg_ref = shift;

  my (@to_keep, %opt);
  for ( my $index = 0; $index <= $#$arg_ref; $index++ )
  {
    if ( $arg_ref->[$index] =~ /\A--(.*)=(.*)/ )
    {
      $opt{$1} = $2;
    }
    else
    {
      push @to_keep, $index;
    }
  }

  @$arg_ref = @$arg_ref[ @to_keep ];
  return \%opt;
}
