#!/usr/local/bin/perl
use strict;
use warnings;

use Test::More tests => 9;
use Test::Exception;
use Test::NoWarnings;

use Oscars;

my $oscar = Oscars->new;

throws_ok { $oscar->populate } qr/No input file/, 'populate fails without input file';

my %criteria = ( year => 1982, category => 'Editing' );
throws_ok { $oscar->winners( %criteria ) } qr/don't have data/, 'winners fails without populate';

$oscar = Oscars->new( input => 'oscars.txt' );
lives_ok { $oscar->populate } 'populate succeeds with input file';

my @winners;
lives_ok{ @winners = $oscar->winners( %criteria ) } 'winners succeeds';

is @winners, 1, 'Correct number of winners found';

is $winners[0], 'John Bloom', 'Correct winner found';

throws_ok { @winners = $oscar->winners( year => 1989, for => 'Editing' ) } qr/need a category/, 'Incorrect criteria';

@winners = $oscar->winners( year => 1989, category => 'Editing' );

is_deeply \@winners, [ 'David Brenner', 'Joe Hutshing' ], 'Multiple winners correct';
