#!/home/peter/perl5/perlbrew/perls/perl-blead/bin/perl5.15.4
#!/usr/local/bin/perl
use strict;
use warnings;

use WWW::Mechanize;
use List::Util qw(sum);
binmode STDOUT, ':utf8';
use Term::ProgressBar;

my $TOP_URL = 'http://www.informit.com/authors/';

my $mech = WWW::Mechanize->new;
$mech->get( $TOP_URL );
$mech->content =~ /Showing\s+1.\d+\s+of\s+(\d+)/ or die "Can't find number of authors";
my $prog = Term::ProgressBar->new( { count => $1, ETA => 'linear' } );

my %author;
while ( 1 )
{
  for my $author_link ( $mech->find_all_links( url_abs_regex => qr!authors/bio! ) )
  {
    # $prog->message( $author_link->text );
    $author{ $author_link->text }++;
    $prog->update;
  }
  my $next_link = $mech->find_link( text_regex => qr/\ANext/ ) or last;
  $mech->get( $next_link );
}
use Data::Dumper;
open my $fh, '>', '/tmp/authors';
print {$fh} Dumper( \%author );

my $dups = sum( map { $_ - 1 } grep { $_ > 1 } values %author );
print "Found " . (keys %author ) . " authors", " ($dups duplicates)\n";
